//     ,
//  .
#include <iostream.h>
#define TRUE 1
#define FALSE 0
#define Node 20 //    .
typedef int Boolean;
typedef struct L *Lref; // :    .
typedef struct T *Tref; // :    .

//   .
typedef struct L 
{ 
  int Key; //  .
  int Count; // .
  Boolean Flag; //    .
  Tref Trail; //   .
  Lref Next; //       .
};

//   .
typedef struct T 
{ 
  Lref Id; 
  Tref Next; 
};

//   .
typedef Lref TipElement; 
typedef struct Zveno *svqz;
typedef struct Zveno
{
  TipElement Element; //   .
  svqz Sled;
};

class Spisok
{
  private:
    Lref Head; //     .
    Lref Tail; //    
               //     .
    int  X[Node+1]; //  .
    void SearchGraph (int, Lref *);
  public:
    Spisok() {//   .
              Head = Tail =  new (L); }
    Lref GetHead() { return Head; }
    Lref GetTail() { return Tail; }
    void MakeGraph ();
    void PrintGraph ();
    void Hamilton (int, int);
    void X1 (Lref t) {X[1] = t->Key;};
};

void main ()
{
  Spisok A;
  Lref t; //    
          //    .
  int n=0;

  //      .
  A.MakeGraph ();
  A.PrintGraph (); cout<<endl;
  //     .
  t = A.GetHead();
  while (t!=A.GetTail())
    { t->Flag = TRUE; n++; t = (*t).Next; }
  // ------------------------------------ 
  //   .
  t = A.GetHead();
  A.X1(t);
  t->Flag = FALSE;
  A.Hamilton (2,n);
} 

void Spisok::SearchGraph (int w, Lref *h)
//      
//  w  ,      Head. 
{
  *h = Head; (*Tail).Key = w;
  while ((**h).Key!=w) *h = (**h).Next;
  if (*h==Tail)
  //        w.
  //     Head.
  { Tail = new (L); (**h).Count = 0; 
    (**h).Trail = NULL; (**h).Next = Tail; }
}

void Spisok::MakeGraph ()
//   Head   
//,   .
{
  int x,y;
  Lref p,q; // .
  Tref t,r; // .
  Boolean Res; //  .
  cout<<"   : ";
  cin>>x;
  while (x!=0)
  {
     cout<<"   : "; cin>>y;
     //,      (x,y)?
     SearchGraph (x, &p); SearchGraph (y,&q);
     r = (*p).Trail; Res = FALSE; 
     while ((r!=NULL)&&(!Res)) 
       if ((*r).Id==q) Res = TRUE; 
       else r = (*r).Next; 
     if (!Res) //  ,     .
      { t = new (T); (*t).Id = q; 
        (*t).Next = (*p).Trail; (*p).Trail = t; (*q).Count++; } 
     cout<<"   : "; cin>>x;
  }
}

void Spisok::PrintGraph ()
//  ,   
//Head    .
{
  Lref p; // .
  Tref q; // .

  p = Head;
  while (p!=Tail)
  {
     cout<< (*p).Key << "("; q = (*p).Trail; 
     while (q!=NULL) 
      { cout<<(*(*q).Id).Key; q = (*q).Next; } 
     cout<<")"; p = (*p).Next; cout<<" ";
  }
}

void Spisok::Hamilton (int k, int n)
//     , 
//    t.
{
  int i;  // .
  Lref t; //  k-   .
  Tref r;

  SearchGraph (X[k-1], &t);
  r = t->Trail;
  while ( r != NULL )
  {
    X[k] = r->Id->Key;
    if  (k==n+1 && X[k]==X[1])
    {
      for (i=1;i<=n;i++) cout << X[i] << " ";
      cout << X[1] << endl;
    }
    else  
      if (r->Id->Flag)
      {
        r->Id->Flag = FALSE;
        Hamilton (k+1,n);
        r->Id->Flag = TRUE;
      }
    r = r->Next;
  }
}
